<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>listContact</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
    <div class="container-fluid ">
        <h2 class="text-center pb-3">DANH SÁCH LIÊN HỆ</h2>
        <table class="table text-center table-striped table-primary" id="table">
            <thead>
                <tr>
                    <th scope="col">STT</th>
                    <th scope="col">Name</th>
                    <th scope="col">Email</th>
                    <th scope="col">Message</th>
                    <th scope="col">Ngày liên hệ</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>

            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gEND_OF_ROW_COL = -1;
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";

    const gREQUEST_DELETE_SUCCESS = 204;
    const vCONTACT_DETAIL = "contactDetail.html";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    //hàm tải trang
    function onPageLoading() {
        getDataContact();
    };

    //hàm xử lý khi click nút sửa
    function onBtnSuaClick(paramSuaClick) {
        var vId = paramSuaClick.dataset.id;
        var vUrl = vCONTACT_DETAIL + "?" + "id=" + vId;
        console.log(vUrl)
        window.location.href = vUrl;

    }

    //hàm xử lý khi click nút sửa
    function onBtnXoaClick(paramXoaClick) {
        var vConfirm = "Bạn có chắc chắn muốn xóa lien hệ này không?"
        var vId = paramXoaClick.dataset.id;
        //ghi ra console
        console.log("ID: " + vId);
        
        if (confirm(vConfirm) == true) {
            //gọi API
            callAPIToDelete(vId);
        }
    };

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm gọi API Xóa đơn hàng theo id
    function callAPIToDelete(paramIDObj) {
        const vAPI_URL = gBASE_URL + "/contacts/";
        var vXmlhttp = new XMLHttpRequest();
        vXmlhttp.open("DELETE", vAPI_URL + paramIDObj, true);
        vXmlhttp.send();

        vXmlhttp.onreadystatechange = function () {
            // xóa thành công contact
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log("Delete contact " + paramIDObj + " thành công!");
                var vResponseText = JSON.parse(vXmlhttp.readyState);
                    console.log(vResponseText);
                    if(vResponseText = 4){
                        alert("Liên hệ đã được xóa");
                    }
                    else{
                        alert("Liên hệ xóa không thành công");
                    }
            }
        }
    }

    // Hàm thực hiện việc load all orders từ server và load vào table
    function getDataContact() {
        var vXmlHttp = new XMLHttpRequest();
        callApiToGetDataContact(vXmlHttp);

        // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
        vXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                loadOrderToTable(vXmlHttp);
                // console.log(vXmlHttp.responseText);
            }
        }
    }

    // hàm gọi api để lấy all orders
    function callApiToGetDataContact(paramXMLHttp) {
        var vAPI_URL = gBASE_URL + "/contacts";
        paramXMLHttp.open("GET", vAPI_URL, true);
        paramXMLHttp.send();
    }

    function loadOrderToTable(paramXMLHttp) {

        var vResponseText = paramXMLHttp.responseText;

        var vResponse = JSON.parse(vResponseText);
        var vTable = document.getElementById("table");
        var vTableTBody = vTable.getElementsByTagName("tbody")[0];
        //thêm row mới vào bảng
        for (var bI = 0; bI < vResponse.length; bI++) {
            var bNewOrderRow = vTableTBody.insertRow(gEND_OF_ROW_COL);
            //thêm cell
            var bSTTCell = bNewOrderRow.insertCell(0);
            var bNameCell = bNewOrderRow.insertCell(1);
            var bEmailCell = bNewOrderRow.insertCell(2);
            var bMessageCell = bNewOrderRow.insertCell(3);
            var bDateCell = bNewOrderRow.insertCell(4);
            var bActionCell = bNewOrderRow.insertCell(5);

            //thêm dũ liệu vào cell
            bSTTCell.innerHTML = vResponse[bI].id;
            bNameCell.innerHTML = vResponse[bI].name;
            bEmailCell.innerHTML = vResponse[bI].email;
            bMessageCell.innerHTML = vResponse[bI].message;
            bDateCell.innerHTML = vResponse[bI].date;

            //Nút chi tiết
            bActionCell.className = "btn-group";
            var bButton = document.createElement("button");
            bButton.textContent = "Sửa";
            bButton.className = "btn btn-success";
            bButton.setAttribute("data-id", vResponse[bI].id);
            bActionCell.appendChild(bButton);
            //thêm sự kiện vào nút
            bButton.addEventListener("click", function () {
                onBtnSuaClick(this);
            });
            //thêm nút delete
            var bButton1 = document.createElement("button");
            bButton1.textContent = "Xóa";
            bButton1.className = "btn btn-danger";
            bButton1.setAttribute("data-id", vResponse[bI].id);
            bActionCell.appendChild(bButton1);
            //them sự kiện vào nút xóa
            bButton1.addEventListener("click", function () {
                onBtnXoaClick(this);
            });
        }
    }

</script>

</html>